#include <wx/wx.h>

extern int*shmgetmatrix(int*rx,int*ry);

class prova0app : public wxApp { public: virtual bool OnInit(); };

class prova0Frame : public wxFrame
{
  public:
    prova0Frame( const wxString& title, const wxPoint& pos, const wxSize& pos );
    void OnQuit( wxCommandEvent& event );
    void OnAbout( wxCommandEvent& event );
    void OnPaint(wxPaintEvent& event);
    void OnMouse(wxMouseEvent& event);
    
  private:
    DECLARE_EVENT_TABLE();
    wxBitmap bm;
    long ppx;
    long ppy;
};

enum
{
  Menu_File_Quit = 100,
  Menu_File_About
};


BEGIN_EVENT_TABLE(prova0Frame,wxFrame)
    EVT_MENU(Menu_File_Quit,prova0Frame::OnQuit)
    EVT_MENU(Menu_File_About,prova0Frame::OnAbout)
    EVT_PAINT(prova0Frame::OnPaint)
    EVT_MOTION(prova0Frame::OnMouse)
    EVT_LEFT_DOWN(prova0Frame::OnMouse)
    EVT_LEFT_UP(prova0Frame::OnMouse)
END_EVENT_TABLE()
    
IMPLEMENT_APP(prova0app)
 
bool prova0app::OnInit()
{
  prova0Frame*frame=new prova0Frame(wxT("TnMandelbrot!"),
                                    wxPoint(50,50),wxSize(640,480));
  frame->Show(TRUE);
  SetTopWindow(frame);
  return TRUE;
} 

prova0Frame::prova0Frame(const wxString&title,const wxPoint&pos,const wxSize&size)
  :wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
  wxMenu *menuFile = new wxMenu;
        
  menuFile->Append( Menu_File_About, wxT( "&About..." ) );
  menuFile->AppendSeparator();
  menuFile->Append( Menu_File_Quit, wxT( "E&xit" ) );
        
  wxMenuBar *menuBar = new wxMenuBar;
  menuBar->Append( menuFile, wxT( "&File" ) );
        
  SetMenuBar( menuBar );
        
  CreateStatusBar();
  SetStatusText( wxT( "TnMandelbrot for LCS 2007  ~  By The_Nihilant 2007   ~  released under GPLv2 or later" ) );
 
 int rx=800;
 int ry=800;
 ppx=0;
 ppy=0;

 int*m=shmgetmatrix(&rx,&ry);
 
 bm=wxBitmap(rx,ry);
 wxMemoryDC dc;
 dc.SelectObject(bm);
 wxPen p=dc.GetPen();
 int i,j;
 
 for(i=0;i<ry;i++)for(j=0;j<rx;j++){ 
  wxColour c(m[i*rx+j]==-1?0:(char)m[i*rx+j],0,m[i*rx+j]==-1?0:char(m[i*rx+j]/256));
  p.SetColour(c);
  dc.SetPen(p);
  dc.DrawPoint(j,i);
 }
}


void prova0Frame::OnMouse(wxMouseEvent& evt){
  long nx,ny;
  static long dragx;
  static long dragy;
  
  if(evt.ButtonDown()){
    dragx=evt.GetX();
    dragy=evt.GetY();
    return; 
  }
  if(evt.Dragging()&&evt.LeftIsDown()){
    nx=evt.GetX();
    ny=evt.GetY();
    ppx+=nx-dragx;
    ppy+=ny-dragy;
    dragx=nx;
    dragy=ny;
    Refresh();
    return;
  }
  
}

void prova0Frame::OnPaint(wxPaintEvent& WXUNUSED(event)) {
 wxPaintDC dc(this);
 dc.DrawBitmap(bm,ppx,ppy);
 
}

void prova0Frame::OnQuit( wxCommandEvent& WXUNUSED( event ) )
{
  Close(TRUE);
}

static void messaggio(const wxString& s){
  wxMessageBox( s,wxT( "TnMandelbrotDisplayer" ), wxOK | wxICON_INFORMATION, NULL );
}
  

void prova0Frame::OnAbout( wxCommandEvent& WXUNUSED( event ) )
{
 messaggio(wxT("Mandelbrot Displayer\n By The_Nihilant 2007\nreleased under GPL license, v2 or later." ));
}

